#include <QtWaylandClient/private/qwayland-hardware-integration.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_hardware_integration::qt_hardware_integration(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_hardware_integration::qt_hardware_integration(struct ::qt_hardware_integration *obj)
        : m_qt_hardware_integration(obj)
    {
        init_listener();
    }

    qt_hardware_integration::qt_hardware_integration()
        : m_qt_hardware_integration(0)
    {
    }

    qt_hardware_integration::~qt_hardware_integration()
    {
    }

    void qt_hardware_integration::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_hardware_integration = static_cast<struct ::qt_hardware_integration *>(wl_registry_bind(registry, id, &qt_hardware_integration_interface, version));
        init_listener();
    }

    void qt_hardware_integration::init(struct ::qt_hardware_integration *obj)
    {
        m_qt_hardware_integration = obj;
        init_listener();
    }

    bool qt_hardware_integration::isInitialized() const
    {
        return m_qt_hardware_integration != 0;
    }

    void qt_hardware_integration::hardware_integration_client_backend(const QString &)
    {
    }

    void qt_hardware_integration::handle_client_backend(
        void *data,
        struct ::qt_hardware_integration *object,
        const char *name)
    {
        Q_UNUSED(object);
        static_cast<qt_hardware_integration *>(data)->hardware_integration_client_backend(
            QString::fromUtf8(name));
    }

    void qt_hardware_integration::hardware_integration_server_backend(const QString &)
    {
    }

    void qt_hardware_integration::handle_server_backend(
        void *data,
        struct ::qt_hardware_integration *object,
        const char *name)
    {
        Q_UNUSED(object);
        static_cast<qt_hardware_integration *>(data)->hardware_integration_server_backend(
            QString::fromUtf8(name));
    }

    const struct qt_hardware_integration_listener qt_hardware_integration::m_qt_hardware_integration_listener = {
        qt_hardware_integration::handle_client_backend,
        qt_hardware_integration::handle_server_backend
    };

    void qt_hardware_integration::init_listener()
    {
        qt_hardware_integration_add_listener(m_qt_hardware_integration, &m_qt_hardware_integration_listener, this);
    }
}

QT_END_NAMESPACE
