#include <QtWaylandClient/private/qwayland-output-extension.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_output_extension::qt_output_extension(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_output_extension::qt_output_extension(struct ::qt_output_extension *obj)
        : m_qt_output_extension(obj)
    {
    }

    qt_output_extension::qt_output_extension()
        : m_qt_output_extension(0)
    {
    }

    qt_output_extension::~qt_output_extension()
    {
    }

    void qt_output_extension::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_output_extension = static_cast<struct ::qt_output_extension *>(wl_registry_bind(registry, id, &qt_output_extension_interface, version));
    }

    void qt_output_extension::init(struct ::qt_output_extension *obj)
    {
        m_qt_output_extension = obj;
    }

    bool qt_output_extension::isInitialized() const
    {
        return m_qt_output_extension != 0;
    }

    struct ::qt_extended_output *qt_output_extension::get_extended_output(struct ::wl_output *output)
    {
        return qt_output_extension_get_extended_output(
            m_qt_output_extension,
            output);
    }

    qt_extended_output::qt_extended_output(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_extended_output::qt_extended_output(struct ::qt_extended_output *obj)
        : m_qt_extended_output(obj)
    {
    }

    qt_extended_output::qt_extended_output()
        : m_qt_extended_output(0)
    {
    }

    qt_extended_output::~qt_extended_output()
    {
    }

    void qt_extended_output::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_extended_output = static_cast<struct ::qt_extended_output *>(wl_registry_bind(registry, id, &qt_extended_output_interface, version));
    }

    void qt_extended_output::init(struct ::qt_extended_output *obj)
    {
        m_qt_extended_output = obj;
    }

    bool qt_extended_output::isInitialized() const
    {
        return m_qt_extended_output != 0;
    }
}

QT_END_NAMESPACE
