#include <QtWaylandClient/private/qwayland-qtkey-extension.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_key_extension::qt_key_extension(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_key_extension::qt_key_extension(struct ::qt_key_extension *obj)
        : m_qt_key_extension(obj)
    {
        init_listener();
    }

    qt_key_extension::qt_key_extension()
        : m_qt_key_extension(0)
    {
    }

    qt_key_extension::~qt_key_extension()
    {
    }

    void qt_key_extension::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_key_extension = static_cast<struct ::qt_key_extension *>(wl_registry_bind(registry, id, &qt_key_extension_interface, version));
        init_listener();
    }

    void qt_key_extension::init(struct ::qt_key_extension *obj)
    {
        m_qt_key_extension = obj;
        init_listener();
    }

    bool qt_key_extension::isInitialized() const
    {
        return m_qt_key_extension != 0;
    }

    void qt_key_extension::dummy()
    {
        qt_key_extension_dummy(
            m_qt_key_extension);
    }

    void qt_key_extension::key_extension_qtkey(struct ::wl_surface *, uint32_t , uint32_t , uint32_t , uint32_t , uint32_t , uint32_t , uint32_t , const QString &, uint32_t , uint32_t )
    {
    }

    void qt_key_extension::handle_qtkey(
        void *data,
        struct ::qt_key_extension *object,
        struct ::wl_surface *surface,
        uint32_t time,
        uint32_t type,
        uint32_t key,
        uint32_t modifiers,
        uint32_t nativeScanCode,
        uint32_t nativeVirtualKey,
        uint32_t nativeModifiers,
        const char *text,
        uint32_t autorepeat,
        uint32_t count)
    {
        Q_UNUSED(object);
        static_cast<qt_key_extension *>(data)->key_extension_qtkey(
            surface,
            time,
            type,
            key,
            modifiers,
            nativeScanCode,
            nativeVirtualKey,
            nativeModifiers,
            QString::fromUtf8(text),
            autorepeat,
            count);
    }

    const struct qt_key_extension_listener qt_key_extension::m_qt_key_extension_listener = {
        qt_key_extension::handle_qtkey
    };

    void qt_key_extension::init_listener()
    {
        qt_key_extension_add_listener(m_qt_key_extension, &m_qt_key_extension_listener, this);
    }
}

QT_END_NAMESPACE
