#include <QtWaylandClient/private/qwayland-sub-surface-extension.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_sub_surface_extension::qt_sub_surface_extension(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_sub_surface_extension::qt_sub_surface_extension(struct ::qt_sub_surface_extension *obj)
        : m_qt_sub_surface_extension(obj)
    {
    }

    qt_sub_surface_extension::qt_sub_surface_extension()
        : m_qt_sub_surface_extension(0)
    {
    }

    qt_sub_surface_extension::~qt_sub_surface_extension()
    {
    }

    void qt_sub_surface_extension::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_sub_surface_extension = static_cast<struct ::qt_sub_surface_extension *>(wl_registry_bind(registry, id, &qt_sub_surface_extension_interface, version));
    }

    void qt_sub_surface_extension::init(struct ::qt_sub_surface_extension *obj)
    {
        m_qt_sub_surface_extension = obj;
    }

    bool qt_sub_surface_extension::isInitialized() const
    {
        return m_qt_sub_surface_extension != 0;
    }

    struct ::qt_sub_surface *qt_sub_surface_extension::get_sub_surface_aware_surface(struct ::wl_surface *surface)
    {
        return qt_sub_surface_extension_get_sub_surface_aware_surface(
            m_qt_sub_surface_extension,
            surface);
    }

    qt_sub_surface::qt_sub_surface(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_sub_surface::qt_sub_surface(struct ::qt_sub_surface *obj)
        : m_qt_sub_surface(obj)
    {
    }

    qt_sub_surface::qt_sub_surface()
        : m_qt_sub_surface(0)
    {
    }

    qt_sub_surface::~qt_sub_surface()
    {
    }

    void qt_sub_surface::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_sub_surface = static_cast<struct ::qt_sub_surface *>(wl_registry_bind(registry, id, &qt_sub_surface_interface, version));
    }

    void qt_sub_surface::init(struct ::qt_sub_surface *obj)
    {
        m_qt_sub_surface = obj;
    }

    bool qt_sub_surface::isInitialized() const
    {
        return m_qt_sub_surface != 0;
    }

    void qt_sub_surface::attach_sub_surface(struct ::qt_sub_surface *sub_surface, int32_t x, int32_t y)
    {
        qt_sub_surface_attach_sub_surface(
            m_qt_sub_surface,
            sub_surface,
            x,
            y);
    }

    void qt_sub_surface::move_sub_surface(struct ::qt_sub_surface *sub_surface, int32_t x, int32_t y)
    {
        qt_sub_surface_move_sub_surface(
            m_qt_sub_surface,
            sub_surface,
            x,
            y);
    }

    void qt_sub_surface::raise(struct ::qt_sub_surface *sub_surface)
    {
        qt_sub_surface_raise(
            m_qt_sub_surface,
            sub_surface);
    }

    void qt_sub_surface::lower(struct ::qt_sub_surface *sub_surface)
    {
        qt_sub_surface_lower(
            m_qt_sub_surface,
            sub_surface);
    }
}

QT_END_NAMESPACE
