#include <QtWaylandClient/private/qwayland-text.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    wl_text_input::wl_text_input(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    wl_text_input::wl_text_input(struct ::wl_text_input *obj)
        : m_wl_text_input(obj)
    {
        init_listener();
    }

    wl_text_input::wl_text_input()
        : m_wl_text_input(0)
    {
    }

    wl_text_input::~wl_text_input()
    {
    }

    void wl_text_input::init(struct ::wl_registry *registry, int id, int version)
    {
        m_wl_text_input = static_cast<struct ::wl_text_input *>(wl_registry_bind(registry, id, &wl_text_input_interface, version));
        init_listener();
    }

    void wl_text_input::init(struct ::wl_text_input *obj)
    {
        m_wl_text_input = obj;
        init_listener();
    }

    bool wl_text_input::isInitialized() const
    {
        return m_wl_text_input != 0;
    }

    void wl_text_input::activate(struct ::wl_seat *seat, struct ::wl_surface *surface)
    {
        wl_text_input_activate(
            m_wl_text_input,
            seat,
            surface);
    }

    void wl_text_input::deactivate(struct ::wl_seat *seat)
    {
        wl_text_input_deactivate(
            m_wl_text_input,
            seat);
    }

    void wl_text_input::show_input_panel()
    {
        wl_text_input_show_input_panel(
            m_wl_text_input);
    }

    void wl_text_input::hide_input_panel()
    {
        wl_text_input_hide_input_panel(
            m_wl_text_input);
    }

    void wl_text_input::reset()
    {
        wl_text_input_reset(
            m_wl_text_input);
    }

    void wl_text_input::set_surrounding_text(const QString &text, uint32_t cursor, uint32_t anchor)
    {
        wl_text_input_set_surrounding_text(
            m_wl_text_input,
            text.toUtf8().constData(),
            cursor,
            anchor);
    }

    void wl_text_input::set_content_type(uint32_t hint, uint32_t purpose)
    {
        wl_text_input_set_content_type(
            m_wl_text_input,
            hint,
            purpose);
    }

    void wl_text_input::set_cursor_rectangle(int32_t x, int32_t y, int32_t width, int32_t height)
    {
        wl_text_input_set_cursor_rectangle(
            m_wl_text_input,
            x,
            y,
            width,
            height);
    }

    void wl_text_input::set_preferred_language(const QString &language)
    {
        wl_text_input_set_preferred_language(
            m_wl_text_input,
            language.toUtf8().constData());
    }

    void wl_text_input::commit_state(uint32_t serial)
    {
        wl_text_input_commit_state(
            m_wl_text_input,
            serial);
    }

    void wl_text_input::invoke_action(uint32_t button, uint32_t index)
    {
        wl_text_input_invoke_action(
            m_wl_text_input,
            button,
            index);
    }

    void wl_text_input::text_input_enter(struct ::wl_surface *)
    {
    }

    void wl_text_input::handle_enter(
        void *data,
        struct ::wl_text_input *object,
        struct ::wl_surface *surface)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_enter(
            surface);
    }

    void wl_text_input::text_input_leave()
    {
    }

    void wl_text_input::handle_leave(
        void *data,
        struct ::wl_text_input *object)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_leave();
    }

    void wl_text_input::text_input_modifiers_map(wl_array *)
    {
    }

    void wl_text_input::handle_modifiers_map(
        void *data,
        struct ::wl_text_input *object,
        wl_array *map)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_modifiers_map(
            map);
    }

    void wl_text_input::text_input_input_panel_state(uint32_t )
    {
    }

    void wl_text_input::handle_input_panel_state(
        void *data,
        struct ::wl_text_input *object,
        uint32_t state)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_input_panel_state(
            state);
    }

    void wl_text_input::text_input_preedit_string(uint32_t , const QString &, const QString &)
    {
    }

    void wl_text_input::handle_preedit_string(
        void *data,
        struct ::wl_text_input *object,
        uint32_t serial,
        const char *text,
        const char *commit)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_preedit_string(
            serial,
            QString::fromUtf8(text),
            QString::fromUtf8(commit));
    }

    void wl_text_input::text_input_preedit_styling(uint32_t , uint32_t , uint32_t )
    {
    }

    void wl_text_input::handle_preedit_styling(
        void *data,
        struct ::wl_text_input *object,
        uint32_t index,
        uint32_t length,
        uint32_t style)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_preedit_styling(
            index,
            length,
            style);
    }

    void wl_text_input::text_input_preedit_cursor(int32_t )
    {
    }

    void wl_text_input::handle_preedit_cursor(
        void *data,
        struct ::wl_text_input *object,
        int32_t index)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_preedit_cursor(
            index);
    }

    void wl_text_input::text_input_commit_string(uint32_t , const QString &)
    {
    }

    void wl_text_input::handle_commit_string(
        void *data,
        struct ::wl_text_input *object,
        uint32_t serial,
        const char *text)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_commit_string(
            serial,
            QString::fromUtf8(text));
    }

    void wl_text_input::text_input_cursor_position(int32_t , int32_t )
    {
    }

    void wl_text_input::handle_cursor_position(
        void *data,
        struct ::wl_text_input *object,
        int32_t index,
        int32_t anchor)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_cursor_position(
            index,
            anchor);
    }

    void wl_text_input::text_input_delete_surrounding_text(int32_t , uint32_t )
    {
    }

    void wl_text_input::handle_delete_surrounding_text(
        void *data,
        struct ::wl_text_input *object,
        int32_t index,
        uint32_t length)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_delete_surrounding_text(
            index,
            length);
    }

    void wl_text_input::text_input_keysym(uint32_t , uint32_t , uint32_t , uint32_t , uint32_t )
    {
    }

    void wl_text_input::handle_keysym(
        void *data,
        struct ::wl_text_input *object,
        uint32_t serial,
        uint32_t time,
        uint32_t sym,
        uint32_t state,
        uint32_t modifiers)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_keysym(
            serial,
            time,
            sym,
            state,
            modifiers);
    }

    void wl_text_input::text_input_language(uint32_t , const QString &)
    {
    }

    void wl_text_input::handle_language(
        void *data,
        struct ::wl_text_input *object,
        uint32_t serial,
        const char *language)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_language(
            serial,
            QString::fromUtf8(language));
    }

    void wl_text_input::text_input_text_direction(uint32_t , uint32_t )
    {
    }

    void wl_text_input::handle_text_direction(
        void *data,
        struct ::wl_text_input *object,
        uint32_t serial,
        uint32_t direction)
    {
        Q_UNUSED(object);
        static_cast<wl_text_input *>(data)->text_input_text_direction(
            serial,
            direction);
    }

    const struct wl_text_input_listener wl_text_input::m_wl_text_input_listener = {
        wl_text_input::handle_enter,
        wl_text_input::handle_leave,
        wl_text_input::handle_modifiers_map,
        wl_text_input::handle_input_panel_state,
        wl_text_input::handle_preedit_string,
        wl_text_input::handle_preedit_styling,
        wl_text_input::handle_preedit_cursor,
        wl_text_input::handle_commit_string,
        wl_text_input::handle_cursor_position,
        wl_text_input::handle_delete_surrounding_text,
        wl_text_input::handle_keysym,
        wl_text_input::handle_language,
        wl_text_input::handle_text_direction
    };

    void wl_text_input::init_listener()
    {
        wl_text_input_add_listener(m_wl_text_input, &m_wl_text_input_listener, this);
    }

    wl_text_input_manager::wl_text_input_manager(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    wl_text_input_manager::wl_text_input_manager(struct ::wl_text_input_manager *obj)
        : m_wl_text_input_manager(obj)
    {
    }

    wl_text_input_manager::wl_text_input_manager()
        : m_wl_text_input_manager(0)
    {
    }

    wl_text_input_manager::~wl_text_input_manager()
    {
    }

    void wl_text_input_manager::init(struct ::wl_registry *registry, int id, int version)
    {
        m_wl_text_input_manager = static_cast<struct ::wl_text_input_manager *>(wl_registry_bind(registry, id, &wl_text_input_manager_interface, version));
    }

    void wl_text_input_manager::init(struct ::wl_text_input_manager *obj)
    {
        m_wl_text_input_manager = obj;
    }

    bool wl_text_input_manager::isInitialized() const
    {
        return m_wl_text_input_manager != 0;
    }

    struct ::wl_text_input *wl_text_input_manager::create_text_input()
    {
        return wl_text_input_manager_create_text_input(
            m_wl_text_input_manager);
    }
}

QT_END_NAMESPACE
