#include <QtWaylandClient/private/qwayland-windowmanager.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_windowmanager::qt_windowmanager(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_windowmanager::qt_windowmanager(struct ::qt_windowmanager *obj)
        : m_qt_windowmanager(obj)
    {
        init_listener();
    }

    qt_windowmanager::qt_windowmanager()
        : m_qt_windowmanager(0)
    {
    }

    qt_windowmanager::~qt_windowmanager()
    {
    }

    void qt_windowmanager::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_windowmanager = static_cast<struct ::qt_windowmanager *>(wl_registry_bind(registry, id, &qt_windowmanager_interface, version));
        init_listener();
    }

    void qt_windowmanager::init(struct ::qt_windowmanager *obj)
    {
        m_qt_windowmanager = obj;
        init_listener();
    }

    bool qt_windowmanager::isInitialized() const
    {
        return m_qt_windowmanager != 0;
    }

    void qt_windowmanager::open_url(uint32_t remaining, const QString &url)
    {
        qt_windowmanager_open_url(
            m_qt_windowmanager,
            remaining,
            url.toUtf8().constData());
    }

    void qt_windowmanager::windowmanager_hints(int32_t )
    {
    }

    void qt_windowmanager::handle_hints(
        void *data,
        struct ::qt_windowmanager *object,
        int32_t show_is_fullscreen)
    {
        Q_UNUSED(object);
        static_cast<qt_windowmanager *>(data)->windowmanager_hints(
            show_is_fullscreen);
    }

    void qt_windowmanager::windowmanager_quit()
    {
    }

    void qt_windowmanager::handle_quit(
        void *data,
        struct ::qt_windowmanager *object)
    {
        Q_UNUSED(object);
        static_cast<qt_windowmanager *>(data)->windowmanager_quit();
    }

    const struct qt_windowmanager_listener qt_windowmanager::m_qt_windowmanager_listener = {
        qt_windowmanager::handle_hints,
        qt_windowmanager::handle_quit
    };

    void qt_windowmanager::init_listener()
    {
        qt_windowmanager_add_listener(m_qt_windowmanager, &m_qt_windowmanager_listener, this);
    }
}

QT_END_NAMESPACE
