#ifndef QT_WAYLAND_XCOMPOSITE
#define QT_WAYLAND_XCOMPOSITE

#include "wayland-xcomposite-client-protocol.h"
#include <QByteArray>
#include <QString>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    class  qt_xcomposite
    {
    public:
        qt_xcomposite(struct ::wl_registry *registry, int id, int version);
        qt_xcomposite(struct ::qt_xcomposite *object);
        qt_xcomposite();

        virtual ~qt_xcomposite();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::qt_xcomposite *object);

        struct ::qt_xcomposite *object() { return m_qt_xcomposite; }
        const struct ::qt_xcomposite *object() const { return m_qt_xcomposite; }

        bool isInitialized() const;

        struct ::wl_buffer *create_buffer(uint32_t x_window, int32_t width, int32_t height);

    protected:
        virtual void xcomposite_root(const QString &display_name, uint32_t root_window);

    private:
        void init_listener();
        static const struct qt_xcomposite_listener m_qt_xcomposite_listener;
        static void handle_root(
            void *data,
            struct ::qt_xcomposite *object,
            const char *display_name,
            uint32_t root_window);
        struct ::qt_xcomposite *m_qt_xcomposite;
    };
}

QT_END_NAMESPACE

#endif
